/*-
 * Copyright (c) 2000-2001
 * Tatsuya Kudoh(CDR/TK),ROYALPANDA.    All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef _KSKBD_H_
#define _KSKBD_H_

#include"kskernel.h"

#define KS_INPUT_MODE_RAW	0
#define KS_INPUT_MODE_KBD	1
#define KS_INPUT_MODE_CONV1	2
#define KS_INPUT_MODE_CONV2	3

#define KS_KBD_MODE_HIRA	0
#define KS_KBD_MODE_KATA	1
#define KS_KBD_MODE_ASCII	2

typedef int (*KSKeyHandler)(KSMsg *msg);

void KSResetKeyboard( void );
void KSSetKeyboardMode( int mode );
int KSGetInputMode( void );
void KSSetInputMode( int mode );
void KSInitializeKeyboard( void );
void KSGetKeyRepeat( unsigned *delay, unsigned *interval );
void KSSetKeyRepeat( unsigned delay, unsigned interval );
int KSKeyboard( unsigned tick );
int KSSetKeyHandler( KSKeyHandler handler, void *call_data );
void KSRemoveKeyHandler( void );

#endif
